%define name sablevm-sdk
%define subname sablevm
%define version 1.12
%define release 1mdk
%define cpversion 0.16

#-- JRE version
%define JRE_VERSION 1.1.2
# This is what Kaffe uses in MDK 10.  I don't know what SableVM supports.

#-- Alternatives for Java tools
#	Sun JDK		40
#	Kaffe		30
#	Gcj 3.1		20
%define alternatives_priority 10

Summary: Java SDK environment built around SableVM
Name: %{name}
Version: %{version}
Release: %{release}
Packager: Stephen Compall <s11@member.fsf.org>
Source0: %{name}-%{version}.tar.bz2
Source1: kaffe-jdk-config.bz2
License: LGPL
Group: Development/Java
Url: http://sablevm.org/
Provides: jre = %{JRE_VERSION}
PreReq: /usr/sbin/update-alternatives
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: libffi2-devel, popt-devel, libltdl3-devel
BuildRequires: jikes >= 1.22, libgtk+2.0_0-devel >= 2.4
BuildRequires: libglib2.0_0-devel >= 2.4, libart_lgpl2-devel
BuildRequires: antlr >= 2.7.1
Requires: sablevm = %{version}, sablevm-classpath = %{version}
Requires: sablevm-devel = %{version}, sablevm-jni-devel = %{version}

%description
This is a Java runtime and software development kit based around
SableVM, the extremely portable, cutting-edge Java virtual machine,
and GNU Classpath, the free standard libraries for Java.  It is a pure
dependency package that installs everything you need to develop and
run Java programs in a free environment.

%package -n sablevm
Summary: An extremely portable, cutting-edge Java VM
Group: Development/Java
Requires: sablevm-classpath = %{version}, unzip
%description -n sablevm
SableVM is a highly portable JVM, with clean code (thanks to GNU M4),
Java standards compliance, frequent releases, and a fairly close
tracking of GNU Classpath, so you can be sure that your Java software
is running with the best Classpath available.

Though actively developed, SableVM is extremely stable, even in its
Subversion development repository.

%package -n sablevm-classpath
Summary: GNU Classpath customized for use with SableVM
Group: System/Libraries
Requires: sablevm = %{version}
%description -n sablevm-classpath
This package contains GNU's essential libraries for Java,
version %{cpversion}, customized for use with SableVM.
You need it to run Java programs with SableVM.

%package -n sablevm-devel
Summary: Java to bytecode compilation in a SableVM environment
Group: Development/Java
Provides: jdk = %{JDK_VERSION}
Requires: jikes >= 1.22, sablevm-classpath = %{version}
Requires: antlr >= 2.7.1
%description -n sablevm-devel
This package contains emulation of the standard JDK tools in SableVM.

javac-sablevm: This is a wrapper around IBM Jikes that points Jikes to
the standard SableVM GNU Classpath installation, so you can run
`javac' without worrying about setting up the classpath properly.

jar-sablevm: This is a trivial wrapper around fastjar.

SableVM is a highly portable JVM, with clean code (thanks to GNU M4),
Java standards compliance, frequent releases, and a fairly close
tracking of GNU Classpath, so you can be sure that your Java software
is running with the best Classpath available.

%package -n sablevm-jni-devel
Summary: JNI headers and scripts
Group: Development/Java
Requires: sablevm = %{version}
%description -n sablevm-jni-devel
Install this package if you want to build native libraries that can be
called from Java running in SableVM.

SableVM is a highly portable JVM, with clean code (thanks to GNU M4),
Java standards compliance, frequent releases, and a fairly close
tracking of GNU Classpath, so you can be sure that your Java software
is running with the best Classpath available.

%prep
%setup0 -q

%build
%define __libtoolize true
%configure2_5x
%make

%install
make DESTDIR="$RPM_BUILD_ROOT" install

# Add jdk-config scriptlet
(cd "$RPM_BUILD_ROOT%{_bindir}/";
  SED_PATTERN="s|@JDK_VERSION@|%{JRE_VERSION}|;s|@JDK_INCLUDES@|-I%{_includedir}/sablevm|;"
  bzcat %{SOURCE1} | sed -e "$SED_PATTERN" > sablevm-jdk-config-%{version}
  chmod 0755 sablevm-jdk-config-%{version}
# Alternatives provide java and jdk-config script (huh? kaffe does it)
# Also create fake alternatives in the original dir (huh? same thing)
  touch java
  chmod 0755 java
  touch jdk-config
  chmod 0755 jdk-config
  touch javac
  chmod 0755 javac
  touch jar
  chmod 0755 jar
)

# move jni headers
(cd "$RPM_BUILD_ROOT%{_includedir}";
  test -d sablevm/ || mkdir sablevm
  mv *.h sablevm/
)

%clean
test "x$RPM_BUILD_ROOT" != x/ && rm -rf "$RPM_BUILD_ROOT"

%post -n sablevm
update-alternatives --install %{_bindir}/java java %{_bindir}/java-sablevm %{alternatives_priority}

%postun -n sablevm
test ! -f %{_bindir}/java-sablevm && update-alternatives --remove java %{_bindir}/java-sablevm || :

%post -n sablevm-devel
update-alternatives --install %{_bindir}/javac javac %{_bindir}/javac-sablevm %{alternatives_priority}
update-alternatives --install %{_bindir}/jar jar %{_bindir}/jar-sablevm %{alternatives_priority}

%postun -n sablevm-devel
test ! -f %{_bindir}/javac-sablevm && update-alternatives --remove javac %{_bindir}/javac-sablevm || :
test ! -f %{_bindir}/jar-sablevm && update-alternatives --remove jar %{_bindir}/jar-sablevm || :

%post -n sablevm-jni-devel
update-alternatives --install %{_bindir}/jdk-config jdk-config %{_bindir}/sablevm-jdk-config-%{version} %{alternatives_priority}

%postun -n sablevm-jni-devel
test ! -f %{_bindir}/sablevm-jdk-config-%{version} && update-alternatives --remove jdk-config %{_bindir}/sablevm-jdk-config-%{version} || :


%files -n sablevm
%defattr(-,root,root,-)
%doc sablevm/AUTHORS sablevm/ChangeLog sablevm/LICENSE sablevm/LGPL-2.1 sablevm/NEWS sablevm/README sablevm/THANKS
%{_bindir}/sablevm
%{_bindir}/java-sablevm
%ghost %{_bindir}/java
%{_mandir}/man1/*
%{_libdir}/libsablevm-%{version}.so
%{_libdir}/libsablevm.la
%{_libdir}/libsablevm.so
%{_datadir}/sablevm

%files -n sablevm-classpath
%defattr(-,root,root,-)
%doc sablevm-classpath/AUTHORS sablevm-classpath/ChangeLog sablevm-classpath/ChangeLog.sablevm-classpath sablevm-classpath/COPYING sablevm-classpath/LICENSE
%doc sablevm-classpath/NEWS sablevm-classpath/README sablevm-classpath/THANKYOU sablevm-classpath/TODO
%{_datadir}/sablevm-classpath
%{_libdir}/sablevm-classpath
%{_libdir}/security

%files -n sablevm-devel
%defattr(-,root,root,-)
%doc sablevm/AUTHORS sablevm/ChangeLog sablevm/LICENSE sablevm/LGPL-2.1 sablevm/NEWS sablevm/README sablevm/THANKS
%{_bindir}/jar-sablevm
%{_bindir}/javac-sablevm
%{_libdir}/sablevm
%ghost %{_bindir}/jar
%ghost %{_bindir}/javac

%files -n sablevm-jni-devel
%defattr(-,root,root,-)
%doc sablevm/AUTHORS sablevm/ChangeLog sablevm/LICENSE sablevm/LGPL-2.1 sablevm/NEWS sablevm/README sablevm/THANKS
%{_bindir}/sablevm-jdk-config-%{version}
%ghost %{_bindir}/jdk-config
%{_includedir}/sablevm


%changelog
* Wed Jul 13 2005 Stephen Compall <s11@member.fsf.org> 1.12-1mdk
- new release
* Sun Mar 27 2005 Stephen Compall <s11@member.fsf.org> 1.11.3-1mdk
- new release
- redefine __libtoolize macro instead of aliasing the command
* Wed Mar 23 2005 Stephen Compall <s11@member.fsf.org> 1.11.2-1mdk
- new release
* Wed Mar 16 2005 Stephen Compall <s11@member.fsf.org> 1.11-1mdk
- new release
- add javac-sablevm in javac subpackage
* Sun Jan 23 2005 Stephen Compall <s11@member.fsf.org> 1.1.9-1mdk
- new release
- real-life brokenness is now default; removing
- add `devel' package
* Wed Dec 29 2004 Stephen Compall <s11@member.fsf.org> 1.1.8-1mdk
- pre-release, or new release if egagnon doesn't change it
* Thu Nov 11 2004 Stephen Compall <s11@member.fsf.org> 1.1.7-1mdk
- new release
- remove debian patch
* Sun Aug 29 2004 Stephen Compall <s11@member.fsf.org> 1.1.6-3mdk
- always return 0 from %postun
* Sun Aug 29 2004 Stephen Compall <s11@member.fsf.org> 1.1.6-2mdk
- include gadek's Debian patches
- require unzip (for java -jar)
* Sat Jul 10 2004 Stephen Compall <s11@member.fsf.org> 1.1.6-1mdk
- new release
- don't own FHS directories
* Fri Jun 18 2004 Stephen Compall <s11@member.fsf.org> 1.1.5-3mdk
- Add prereq, provides, and alternatives support
- Add jdk-config script unchanged from kaffe
- Move headers to avoid conflict with GCJ <jni.h>
- Require classpath
* Thu Jun 17 2004 Stephen Compall <s11@member.fsf.org> 1.1.5-2mdk
- disable libtoolize in build to prevent loss of .so xtn on libs
* Thu Jun 17 2004 Stephen Compall <s11@member.fsf.org> 1.1.5-1mdk
- Initial RPM attempt (single RPM)
